class Management::ComplaintsController < ManagementController
  include RepositoriesProxy

  def index
  end

  def show
    @complaints = complaint_repository.get_complaints

    @complaints.each  do |c|
      c.user = User.find_by(rid: c.user)
      c.object = learning_object_repository.get_by_rid(c.object)
    end
  end

  def create
    @complaint = Complaint.new(complaint_params)
    @complaint.user = current_user
    @complaint.object = params[:complaint][:object_rid]

    respond_to do |format|
      if complaint_repository.report @complaint
          format.html { redirect_to :back, notice: 'Denúncia realizada com sucesso.' }
      else
        format.html { redirect_to :back, alert: 'Objeto já foi denunciado por você.' }
      end
    end
  end

  def destroy

    object_rid = params["object_rid"]
    user_rid = params["user_rid"]
    complaint_repository.destroy(user_rid, object_rid)

    respond_to do |format|
      format.html { redirect_to :back, notice: 'Complaint was successfully destroyed.' }
    end

  end

  private

  # Never trust parameters from the scary internet, only allow the white list through.
  def complaint_params
    params.require(:complaint).permit(:object, :message, :description)
  end

end
