class Management::InstitutionsController < ManagementController
  before_action :set_institution, only: [:show, :edit, :update, :destroy]

  # GET /management/institutions
  # GET /management/institutions.json
  def index
    @institutions = institution_repository.all || []
  end

  # GET /management/institutions/1
  # GET /management/institutions/1.json
  def show
  end

  # GET /management/institutions/new
  def new
    @institution = Institution.new
  end

  # GET /management/institutions/1/edit
  def edit
  end

  # POST /management/institutions
  # POST /management/institutions.json
  def create
    @institution = Institution.new(institution_params)

    respond_to do |format|
      if institution_repository.create @institution
        format.html { redirect_to [:management, @institution], notice: 'Institution was successfully created.' }
        format.json { render :show, status: :created, location: @institution }
      else
        format.html { render :new }
        format.json { render json: @institution.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /management/institutions/1
  # PATCH/PUT /management/institutions/1.json
  def update
    respond_to do |format|
      if @institution.update(institution_params)
        format.html { redirect_to [:management, @institution], notice: 'Institution was successfully updated.' }
        format.json { render :show, status: :ok, location: @institution }
      else
        format.html { render :edit }
        format.json { render json: @institution.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /management/institutions/1
  # DELETE /management/institutions/1.json
  def destroy
    institution_repository.destroy @institution
    respond_to do |format|
      format.html { redirect_to management_institutions_url, notice: 'Institution was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_institution
      @institution = institution_repository.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def institution_params
      params[:institution]
    end
end
